#ifndef	READCONF_H
#define	READCONF_H

#include "limits.h"

/* Max configuration parameters */
#define	MAXCONF	12

struct {
 int n;
 int l;
 int a;
 char ntoken[MAXLENECHO+4];
 char ltoken[10];
} tplinfo ;


static	char CONFCOMM[MAXCONF][20]=
{
 "sysop",        //0
 "address",		//1
 "robot_name",	//2
 "forward", // enable \disable 3
 "template", 	//4
 "mailcommand",	//5
 "loglevel",		//6
 //paths and files
 "linksfile",	//7
 "helpfile",		//8
 "areafile", 	//9
 "log",			//10
 "killempty",    //11
};

struct _conf {
 char SysOp[CHAR_MAX];
 char Address[CHAR_MAX];
 char Robot_Name[CHAR_MAX];
 //    
 char LinksFile[PATH_MAX];
 char HelpFile[PATH_MAX];
 char logfile[PATH_MAX];
 // Echoes
 char AreaFile[PATH_MAX];
 char Template[CHAR_MAX];
 char MailCommand[PATH_MAX];
 //
 int LogLevel;	// Number
 int Forward;	// 0 - No | 1 - Yes
 int KillEmpty;	// 0 - No | 1 - Yes
 
} conf;

extern ReadConfig();

#endif	/* READCONF_H */
