/* _datefil.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Take timestamp from file. In  TC      ६ ᮧ 䠩.  TC
 * 2.0 there is bug in  stat,  that   2.0     ࠭     stat(),
 * causes stat() unusable for  date   - ண stat()  ⮨  ᯮ-
 * and time of file creation.           ⮣...
 *
 * This function is workaround.          㭪 ।祭  室 .
 * Included in:                                          ᯮ  䠩:
 *                       hasher.c, sqw-os.c
 *
 */

#ifdef __TURBOC__
/*
 * date_from_file()
 *
 */

struct Fdate {
unsigned short	int	day:  5;
unsigned short	int	mnth: 4;
unsigned short	int	year: 7;
		};			/* File DOS datestamp		     */
struct Ftime {
unsigned short	int	sec2:  5;
unsigned short	int	min:   6;
unsigned short	int	hour:  5;
		};			/* File DOS timestamp		     */

unsigned long date_from_file(struct ffblk *f)
{
struct Fdate *fd;
struct Ftime *ft;
struct time tt;
struct date dd;

fd = (struct Fdate *)&(f->ff_fdate);
ft = (struct Ftime *)&(f->ff_ftime);

/** printf("\nyear = %i, month = %i, day = %i\n",
		fd->year + 1980, fd->mnth, fd->day);**/

dd.da_year = fd->year + 1980;
dd.da_mon  = fd->mnth;
dd.da_day  = fd->day;
tt.ti_hour = ft->hour;
tt.ti_min  = ft->min;
tt.ti_sec  = ft->sec2 << 1;
tt.ti_hund = 0;

return dostounix(&dd,&tt);
}

#else
unsigned long date_from_file(char *path)
{
struct stat statbuf;
stat(path, &statbuf);
return statbuf.st_ctime;
}
#endif

