/* pkt2msg.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Small simplest program unpacking
 * .pkt files to messagebase.
 *
 * Now has only *.msg code.
 * Not written yet!!!!!!!!!!!!!!!!!
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "./sqw-hdr.h"
#include "./sqw-os.h"

#define LENGTH 8192

FILE *fin, *fout;
unsigned char	Buffer[LENGTH+1], *s0, *s1, *s2, *s3,
		fname[LENGTH+1],
		mname[LENGTH+1],
		*NowBasePath;

int c, i, j, k, c0, BaseType, nullword = 0;

static char name_tmp[] = "$$$$$$$$.tmp", rb[]="rb", wb[] = "wb";

extern int Cfg[1];

int Cfg[1];

PKT_hdr ph;
MSG_hdr mh;

struct msg {
    unsigned short int  origZone,
                        destZone,
                        origNet,
                        destNet,
                        origNode,
                        destNode,
                        origPoint,
                        destPoint,
			cost,
			AttributeWord;
    char origDomain[9], destDomain[9];
    char *DateTime;
} Mh;

static char From[37], To[37], Subj[73];

void RenameExt(char *, char *);
int BeginAccessBase(char *, int);
int EndAccessBase(void);
int AddMessage (struct msg *, char *, char *, char *, char *, long);

void main(int argc, char **argv)
{

unsigned long length, offset;
char *Buf;

if (argc <= 3)
	{
	puts("Utility unpacks pkt 2+ to messagebase");
	puts("Usage:\n");
	puts("pkt2msg /fido/netmail/ BaseType /fido/out/*.onm\n");
	puts("BaseType: 0 - *.msg");
	puts("Errorlevels:");
	puts("0 - Success; 1 - not enough command line;");
	puts("2 - no file; 3 - Error reading input files");
	puts("4 - no base; 5 - Error writing output files");
	exit(1);
	}
else;

fputs(argv[1], stdout); fputs("<-",stdout);
/* ---------- Check what type of messagebase we have here ---------------- */
BaseType = atoi(argv[2]);
/* ---------- Start access to messagebase procedure ---------------------- */
if (BeginAccessBase(argv[1], BaseType)) exit(4); else;
c0 = '(';
for (i =  3; i < argc; i++)
   {
   if (argc > 3) putc(c0,stdout); else;
   c0 = ',';
   k = strlen(argv[i]);
   s3 = argv[i] + k;
   while ((k-- > 0) && (*s3 != BACKSLASH)) s3--;
   if (*s3 == BACKSLASH) s3++; else;		/* s3 points to fname */

   fputs(s3,stdout);

/* Here:
 *
 * argv[i] is PKT full path name
 *
 */
/* ---------- Just unpacking PKT to messagebase -------------------------- */
   fin = fopen(argv[i], rb);
   if (fin != NULL)
	{
	fread(&ph, sizeof(ph),1,fin);	/* skip packet header */
	Mh.origZone = ph.origZone;
	Mh.destZone = ph.destZone;
	Mh.origPoint = ph.origPoint;
	Mh.destPoint = ph.destPoint;
	do {
	   if ((j = fread(&mh, 1, sizeof(mh), fin)) == sizeof(mh))
		{
/* Message analysing  - - - - - - - - - - - - - - - - - - - - - - - - - - - */
		Mh.origNet = mh.origNet;
		Mh.destNet = mh.destNet;
		Mh.origNode = mh.origNode;
		Mh.destNode = mh.destNode;
		Mh.cost = mh.cost;
		Mh.DateTime = mh.DateTime;
/**/putc('1', stdout);
#define hread(line, limit) s0 = line; j = limit;\
 do { *s0++ = c0 = fgetc(fin); } while ((c0 != 0) && (c0 != EOF) && (j-- > 0));\
 if (c0 != 0) goto Bad_PKT; else;

		hread(To, 37);
		hread(From, 37);
		hread(Subj, 73);
#undef hread
		offset = ftell(fin);
		do c0 = fgetc(fin); while ((c0 != 0) && (c0 != EOF));
		if (c0 == EOF) goto Bad_PKT; else;
		length = ftell(fin) - offset;
		if (length > 65535L) goto Bad_PKT; else;
		fseek(fin, offset, SEEK_SET);
		Buf = malloc((unsigned int)length);
		if (Buf == NULL) goto Bad_PKT; else;
		j = fread(Buf, 1, (unsigned short int)length, fin);
		if (j != length) goto Bad_PKT; else;
		if (AddMessage(&Mh, From, To, Subj, Buf, length)) goto Bad_PKT; else;
		free(Buf);
		}
	   else {
		if ((j == 2) && (mh.PakdMessage == 0))
		   {
		   c0 = EOF;
		   fclose(fin);
		   fin = NULL;
/*		   remove(argv[i]);*/
		   }
		else goto Bad_PKT;
		}
	   }
	while ((c0 != EOF) && (fin != NULL) && (!ferror(fin)));
	if (c0 != EOF) goto Bad_PKT; else;
	}
   else {
Bad_PKT:
	if (fin) fclose(fin); else;
	EndAccessBase();
	RenameExt(argv[i], "bad");
	exit(3);
	}
/* ---------- End of unpacking 1 PKT to messagebase ---------------------- */
   } /* for i < argc */
/* ---------- End access to messagebase procedure ------------------------ */
i = EndAccessBase();
if (argc > 3) putc(')',stdout); else;
putc('\n', stdout);
if (i == 0) exit(0); else exit(5);
} /* main() */

/************* २ ७ 䠩 ****************************/
void RenameExt(char *oldpath, char *t)
{
char newpath[MAXPATH+3];
char *pospath = newpath + strlen(oldpath) - 3;
strcpy (newpath, oldpath);
strcpy (pospath, t);
rename (oldpath,newpath);      /* ⢥ २        */
}

/* ======================================================================= *
 * Very primitive  block  to  write
 * message to .msg base.
 * ----------------------------------------------------------------------- */

/* Next nuber of message generated */
static unsigned long NextMsg = 0L;

int BeginAccessBase(char *path, int type)
{
unsigned long i;
struct ffblk f;

switch(type)
   {
   case 0:		/* .msg */
	sprintf(fname,"%s*.msg", path);
	if (!findfirst(fname, &f, 0))
	   {
	   unsigned long numax = 0L;
	   do	{ unsigned long numnow = atol(f.ff_name);
		if (numnow > numax) numax = numnow; else;
		}
	   while (!findnext(&f));
	   NextMsg = numax;
	   }
/* If no files found here - 1.msg will be created first */
	else NextMsg = 1;
	NowBasePath = path;
	return 0;
   default: break;
   }
return 1;
}

int EndAccessBase()
{
NextMsg = 0L;
return 1;
}

int AddMessage
(struct msg *Mh, char *From, char *To, char *Subj, char *Buf, long length)
{
FILE *f;
struct stat st;

switch(BaseType)
   {
   case 0:
	sprintf(mname, "%s%s", NowBasePath, name_tmp);
	f = fopen(mname, wb);
	if (f == NULL) return 0; else;
	/* 襬  From To Subj (35+0, 35+0, 71+0) */
	s0 = Buffer;
	for (i = 0; i < 72; i++) *s0++ = '\0';
	strcpy(Buffer,To); fwrite((char *)Buffer, 1, 35, f);
	fwrite(&nullword,1,1,f);
	for (i = 0; i < 72; i++) *s0++ = '\0';
	strcpy(Buffer, From); fwrite(Buffer, 1, 35, f);
	fwrite(&nullword,1,1,f);
	for (i = 0; i < 72; i++) *s0++ = '\0';
	strcpy(Buffer, Subj);
	fwrite(Buffer, 1, 71, f);
	fwrite(&nullword,1,1,f);
	/* 襬   ६ */
	fwrite (Mh->DateTime, 1, 19, f); fwrite (&nullword,1,1, f);
	fwrite (&nullword,1,2, f);		/* timesread */
	fwrite (&(Mh->destNode),1,2, f);
	fwrite (&(Mh->origNode),1,2, f);
	fwrite (&(Mh->cost),1,2, f);       /* cost */
	fwrite (&(Mh->origNet),1,2, f);
	fwrite (&(Mh->destNet),1,2, f);
	fwrite (&(Mh->destZone),1,2, f);
	fwrite (&(Mh->origZone),1,2, f);
	fwrite (&(Mh->destPoint),1,2, f);
	fwrite (&(Mh->origPoint),1,2, f);

	fwrite (&nullword,1,2, f);		/* Reply */
	fwrite (&(Mh->AttributeWord),1,2, f);  /* attr */
	fwrite (&nullword,1,2, f);		/* NextReply */
	fwrite (Buf,1,(unsigned int)length, f);	/* message body */
	fwrite (&nullword,1,1,f);
	if (ferror(f)) goto ErrFile; else;
	if (fclose(f) == EOF) goto ErrFile; else;
/* Here temporary file is written properly */
	do sprintf(Buf, "%s%lu.msg", NowBasePath, NextMsg++);
	while ((!stat(Buf, &st)) && (NextMsg < 99999999L));
	if (NextMsg == 99999999L) goto ErrFile; else;
	if (rename(mname, Buf)) goto ErrFile; else;
	break;
   default:
	break;
   } /* switch (BaseType) */
return 0;
ErrFile:
fprintf(stderr, "Error writing message file!\n");
return 1;
} /* AddMessage() */
