/* sqw-prot.h * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Global functions prototypes.       ⨯  㭪権.
 *
 */

#ifndef SQW_PROT_H
#define SQW_PROT_H

unsigned long crc_line(int *);
unsigned long Sqw_cr1(void);
void Sqw_cr2(void);
void Sqw_cr3(void);
void Sqw_cr4(void);
void VerOut(int, FILE *);
void OutLog(int, char*);
void OutLog2(int, char*, char *);
void OutLogA(int, char*);
void Errexit(char *,int);
int Sqw_exist(char*, char*);
void Sqw_ren(char*, char*, char);
void Sqw_Dup_Ren(void);
void Sqw_Dup_Del(void);
int Sqw_ir(void);
void Sqw_pr(void);
void Sqw_md(void);
void Sqw_ms(void);
void Sqw_mw(void);
void Sqw_bt(unsigned int, unsigned int, int, unsigned int);
#if (AREAFIX_STYLE)
int Sqw_afix(unsigned int, unsigned int);
#endif
int Sqw_afix_update(void);
void Sqw_comment(int, int, unsigned int);
int Sqw_adr(char**);
int cr_padr (char **, unsigned int *);
int next_addr(char *, unsigned short int *, unsigned short int *);
char *Path_Tag(char*, unsigned int);
unsigned Find_Tag(char*, unsigned int);
unsigned Find_Next_Tag(char*, unsigned int);
void Sqw_pc(char*);
char *Sqw_ph(char*);
char *sqw_ph(char *);
void RenameEXT(char*, char*);
int Chk_Line (unsigned char*, const char*, const char*, unsigned int);
void AllocPath(char *, char **, int, unsigned int *);
int strcasecmp_match(char *, char *);
int rgx_here(char *);
int rgx_cmp(char *, char *, int);
int rgx_cmp2(char *, int, char *, int);
void rgx_Line(int *, int, int);
int hline(char *, int);
int DirCheck(char *, int);
void Sqw_tolower(void);

void phdatime(PKT_hdr *);
void mhdatime(MSG_hdr *);
time_t Date_From_Line(char *);
void pkt_netmail_begin(unsigned int);
void msg_netmail_begin (unsigned int,unsigned int, char *, char *, char *);
int msg_netmail_end(char *, char *);
void pkt_end(unsigned int, unsigned int);
void Sqw_What_Bad(void);
#endif /* SQW_PROT_H */
