/* sqw-tab.h * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Definitions of character  types'   । ᮢ ⨯ ᨬ  -
 * macroses to work  with  them  as        묨 is* ᠬ.
 * typical isdigit/isalpha, and  my     㦭 ᪨ 
 * own exotic enough IsEOL,...        ।  .
 *
 * hasher writes table to sqw-cfg.c.  hasher 뢠 ⠡  sqw-cfg.c.
 *
 */
#define IsEOMSG(A)  (((A) == '\0') || ((A) == EOF))
#define IsFieldEOL(A) ((A) == '\0')
#define IsEOF(A)    ((A) == EOF)
#define IsDigit(A)  (TabChar[(A)] & 1)
#define IsAlpha(A)  (TabChar[(A)] & 2)
#define IsSpace(A)  (TabChar[(A)] & 4)
#define IsEOL(A)    (TabChar[(A)] & 8)
#define IsCfgEOL(A) (TabChar[(A)] & (16 | 8))
#define IsCfgEOLSpace(A) (TabChar[(A)] & (16 | 8 | 4))
#define IsMsgEOL(A) (TabChar[(A)] & (32 | 8))

#define init_tab_char() tabchar[0] = 4 | 8 | 16 | 32;\
{ register int i;\
for (i = 0; i < 256; i++)\
    {\
    if (isdigit(i)) tabchar[i+1] = 1; else tabchar[i+1] = 0;\
    if (isalpha(i)) tabchar[i+1] |= 2; else;\
    if ((i == ' ') || (i == '\t')) tabchar[i+1] |= 4; else;\
    if ((i == '\r') || (i == '\n')) tabchar[i+1] |= 8; else;\
    if ((i == ';') || (i == '\0')) tabchar[i+1] |= 16; else;\
    if (i == '\0') tabchar[i+1] |= 32; else;\
    }\
}
