/* sqwcre.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Small utility.                      ⨫, ᮧ "
 * Creates 'bad message' for sqafix   ᠣ"  sqafix Autocreate.
 * for autocreation process.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include "./sqw-os.h"   /* OS-aware definitions */
#include "./sqw-cfg.h"
#include "./_match.c"

#define skipword(A) while ((*s0 != ' ') && (*s0 != '\t') && (*s0 != ';') &&\
             (*s0 != '\0') && (*s0 != '\r') && (*s0 != '\n')) s0++;\
             if ((*s0 != ' ') && (*s0 != '\t')) goto A; else

#define skipspace(A)  while ((*s0 == ' ') || (*s0 == '\t')) s0++;\
      if ((*s0 == '\0') || (*s0 == '\r') || (*s0 == '\n') || (*s0 == ';'))\
	  goto A; else

FILE *filepkt;
struct ffblk f;
static time_t ttt;
int Cfg[Cfg_Verbs_Num];
unsigned int i, msgnum;
unsigned int OutFileLowerCase = 0, Clean = 0;

char rb[]="rb";
char wb[]="wb";
char *sqwish_cfg = "sq-echo.cfg";
char SqWcre[] = "SqWcre";
char *Buffer;
char *PathArea;
char *PathFile;
char *Area = NULL;
char *Addr = NULL;
char *msg[] = {"MSG", "msg"};
char timeline[20];

unsigned int Zone,Net,Node,Point, nullword = 0;
unsigned int MyZone,MyNet,MyNode,MyPoint, Addr_First = 1;

/************************** function Main **********************************/
void main (int argc, char *argv[])
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0               */
#endif
register char *s0;
char *s1;
int result;

/* - - - - - - ⢥ ᯮ塞  - - - - - - - - - - - - - - - - - */
Buffer = malloc(32767);
PathArea = malloc(MAXPATH);
PathFile = malloc(MAXPATH);
if ((Buffer == NULL) || (PathArea == NULL) || (PathFile == NULL))  goto ErrMem;
else;
/* ======================= Command Line analysing first - config file name  */
if (argc == 1) goto Help; else;
if (argc > 1)
   for (i = 1; i < argc; i++)
	{
	s0 = argv[i];
	if (*s0++ == '-')
	   {
	   if (toupper(*s0) == 'C') sqwish_cfg = s0+1;
	   if (toupper(*s0) == 'D') Clean = 1;
	   if  (((*s0) == '?') || (!stricmp(s0,"-help")))
		{
Help:
		puts ("\n\nSmall utility writing 'Bad message' for sqafix");
		puts ("Usage:");
		puts ("sqwcre [SqWitches] addresse areatag");
		puts ("\nSqWitches:");
		puts ("-csq-echo.cfg\t- override sq-echo.cfg file");
		puts ("-d\t\t- Clean previously created messages");
		puts ("--help -?\t- this help");
		exit (3);
		}
	   } /* *s0 == '-' */
	else
	   if (Addr == NULL)
	        {
	        Addr = --s0;
/* 砥 ࠬ  ࠢ⥫ ᠣ */
		result = sscanf(s0, "%u:%u/%u.%u",
				&Zone, &Net, &Node, &Point);
		if (result != 4) Point = 0; else;
		}
	   else {
/* 뢠 窨  宮, ᫨    । */
		Area = --s0;
		if (*s0 == '"') Area++; else;
		while (*s0) s0++;
		s0--;
		if (*s0 == '"') *s0 = '\0'; else;
	        }
	} /* for i < argc */

if ((filepkt = fopen(sqwish_cfg,rb)) == NULL) /* ࠭ 뫮 rt */
   {
   printf("Can't open config file %s", sqwish_cfg);
   exit(1);
   }
else;

if ((!Clean) && ((Addr == NULL) || (Area == NULL))) goto ErrArgs; else;

while (fgets(Buffer, 32766, filepkt))
   {
/* ࠬ LowerCase    ७ 䠩  ⮦ 㠫 */
   if (!strcasecmp_match(Buffer,"OutFileLowerCase*"))
      OutFileLowerCase = 1;
   else;
/* 砥 ࠬ ᮡ⢥  */
   if (Addr_First && (!strcasecmp_match(Buffer,"Address*")))
      {
      s0 = Buffer;
      Addr_First = 0;
      skipword(ErrAddr);
      skipspace(ErrAddr);
      s1 = s0;
      result = sscanf(s1, "%u:%u/%u.%u", &MyZone, &MyNet, &MyNode, &MyPoint);
      if (result != 4) MyPoint = 0; else;
      }
   else;
/* 砥   BadArea */
   if (!strcasecmp_match(Buffer,"BadArea*"))
      {
      s0 = Buffer;
      skipword(ErrDir); skipspace(ErrDir); /* skip BadArea */
      skipword(ErrDir); skipspace(ErrDir); /* skip tag of BadArea */
      s1 = s0;
      while ((*s0 != '\0') && (*s0 != '\r') &&
	     (*s0 != ';') && (*s0 != '\n')) s0++;
      *s0 = '\0';
      if (strlen(s1) > (MAXPATH-13)) goto ErrDir; else;
      s0--;
      if (*s0 == BACKSLASH) *s0 = '\0'; /*  \ ᫨   */
      strcpy(PathArea,s1);
      }
   else;
   } /* while (fgets) */
fclose (filepkt);

#if DEBUG
/**/ printf ("PathArea = \"%s\"; OutFileLowerCase = %u; Clean = %u\n",
/**/		PathArea, OutFileLowerCase, Clean);
/**/ printf ("MyAddress = %u:%u/%u.%u\n", MyZone, MyNet, MyNode, MyPoint);
/**/ printf ("  Address = %u:%u/%u.%u\n", Zone, Net, Node, Point);
/**/ printf ("  AreaTag = %s\n", Area);
#endif

/* ந     */
sprintf(PathFile, "%s%c*.%s", PathArea, BACKSLASH, msg[OutFileLowerCase]);


/* ⪠ ᢮ ᮡ⢥ ᠣ */
if (Clean)
	{
	if (findfirst(PathFile, &f, 0)) goto Success; /* ᠣ  ᮢᥬ */
	else do	{
		sprintf(PathFile, "%s%c%s", PathArea, BACKSLASH, f.ff_name);
		if ((filepkt = fopen(PathFile,rb)) != NULL)
			{
			fread(Buffer,1,36,filepkt);   /* ⠥  from */
			fclose(filepkt);
			if (strcmp(Buffer, SqWcre) == 0) /* ᫨  - */
				if (remove(PathFile))	 /*      */
					printf ("Error deleting file %s",
						PathFile);
				else;
			else;
			}
		else printf ("Error reading file %s", PathFile);
		}
	     while (!findnext(&f));
	} /* if Clean */
else	{
	msgnum = 1;
	if (findfirst(PathFile, &f, 0))
	     goto CreateFile;
	else do	{
		if (sscanf(f.ff_name, "%u.", &i) == 1)
		   if (i > msgnum) msgnum = i; else;
		else;
		}
	     while (!findnext(&f));
	msgnum++;
CreateFile:
	sprintf(PathFile, "%s%c%u.%s",
		PathArea, BACKSLASH, msgnum, msg[OutFileLowerCase]);
#if DEBUG
/**/printf ("PathFile = %s\n", PathFile);
#endif
	filepkt = fopen(PathFile, wb);
	if (filepkt == NULL) goto ErrFile; else;
	/* ⢥  ᠣ */
	/* 襬  From To Subj (35+0, 35+0, 71+0) */
	s0 = Buffer;
	for (i = 0; i < 72; i++) *s0++ = '\0';
	strcpy(Buffer, SqWcre); fwrite(Buffer, 1, 36, filepkt);
	strcpy(Buffer, SqWcre); fwrite(Buffer, 1, 36, filepkt);
	strcpy(Buffer, "Autocreate message for sqafix");
	fwrite(Buffer, 1, 72, filepkt);
	/* 襬   ६ */
	time(&ttt);
	s0 = (char *)ctime(&ttt);
#if DEBUG
/**/printf ("time result = %lx; ctime result = \"%s\"\n", ttt, s0);
#endif
	s1 = timeline;
	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = *s0++;
	s1 = timeline + 7;
	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = *s0++;
	s1 = timeline + 4;
	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = *s0++;
	s1 = timeline + 14;
	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = *s0++;
	*s1++ = *s0++;	*s1++ = *s0++;
	*s1 = '\0'; s0 += 6;
	s1 = timeline + 11;
	*s1++ = *s0++;	*s1++ = *s0++;	*s1++ = ' ';

	fwrite (timeline, 1, 20, filepkt);
	fwrite (&nullword,1,2, filepkt); /* timesread */
	fwrite (&MyNode,1,2, filepkt);
	fwrite (&Node,1,2, filepkt);
	fwrite (&nullword,1,2, filepkt); /* cost */
	fwrite (&Net,1,2, filepkt);
	fwrite (&MyNet,1,2, filepkt);
	fwrite (&MyZone,1,2, filepkt);
	fwrite (&Zone,1,2, filepkt);
	fwrite (&MyPoint,1,2, filepkt);
	fwrite (&Point,1,2, filepkt);
	fwrite (&nullword,1,2, filepkt); /* Reply */
	fwrite (&nullword,1,2, filepkt); /* attr */
	fwrite (&nullword,1,2, filepkt); /* NextReply */
	
	if (Point) fprintf(filepkt, "\001FMPT %u\r", Point);
	if (MyPoint) fprintf(filepkt, "\001TOPT %u\r", MyPoint);
	fprintf(filepkt, "AREA:%s\r\rEmpty message\r\r--- SqWcre V00.00\r", Area);
	fprintf(filepkt, " * Origin: Empty (%u:%u/%u.%u)\r",
		Zone, Net, Node, Point);
	fprintf(filepkt, "SEEN-BY: %u/%u\r",Net, Node);
	fprintf(filepkt, "\001PATH: %u/%u\r",Net, Node);
	
	*s0 = '\0';
	fwrite (s0,1,1,filepkt);
	if (ferror(filepkt)) goto ErrFile; else;
	if (fclose(filepkt) == EOF) goto ErrFile; else;
	} /* else Clean */
Success:
exit(0);
ErrFile:
printf ("Error writing file %s (code %i)", PathFile, errno);
exit(4);
ErrArgs:
printf ("Wrong number of parametres");
exit(3);
ErrAddr:
printf ("Wrong Address line: \"%s\"\n", Buffer);
exit(2);
ErrDir:
printf ("Wrong BadArea line: \"%s\"\n", Buffer);
exit(2);
ErrMem:
printf ("Not enough memory");
exit(5);
} /* main() */
